﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.8
@EndOfDesignText@
'Static code module FFMPeg_Utils
Sub Process_Globals
	Private FFMpegPath As String = "C:\NoInstApps\ffmpeg\ffmpeg-2022-08-10-git-8fc7f0fdec-full_build\bin\ffmpeg.exe"
End Sub

Public Sub SetPath(Path As String)
	FFMpegPath = Path
End Sub

Public Sub GetPath As String
	Return FFMpegPath
End Sub

'ReplaceArgs = Overwrite default args.  Should be something like:
'Array as Object("-i","path to source file","moreaArgs",..,..,"path to target file")
'Default would be <code>Array as Object("-i","path to source file","-sample_fmt","s16","-ar","44100","-ac","2","path to target file")</code>
'Producing a 44100hz 16bit stereo file
'To use default Args use:<code>Convert(PathToSourceFile,PathToTargetFile,Array())</code>
Public Sub Convert(PathToSourceFile As String,PathToTargetFile As String,ReplaceArgs As List) As ResumableSub
	
	If FFMpegPath = "" Then Return False
	
	File.Delete(PathToTargetFile,"")
	
	Dim Args As List
	Args.Initialize
  
	If ReplaceArgs.Size > 0 Then
		Args = ReplaceArgs
	Else
		Args.AddAll(Array("-i"))
		Args.Add(PathToSourceFile)
'	Args.Add("-bitexact")									'Force FFMPeg to produce a standard 44 byte header
		Args.Add("-sample_fmt")
		Args.Add("s16")
		Args.Add("-ar")
		Args.Add("44100")
		Args.Add("-ac")
		Args.Add("2")
		Args.Add(PathToTargetFile)
	End If
	
	Log(Args)
	
	Dim Sh As Shell
	Sh.Initialize("SH",FFMpegPath,Args)
	Sh.Run(-1)
 
	Wait For SH_ProcessCompleted (Success As Boolean, ExitCode As Int, StdOut As String, StdErr As String)
	
	Return Success And File.Exists(PathToTargetFile,"")
End Sub

